/*
 *  linux/arch/ppc/kernel/root_sd.c
 *
 *  Copyright (C) 1996, by Gary Thomas (gdt@linuxppc.org)
 *
 *  Set root device to be "/dev/sda1"
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version
 *  2 of the License, or (at your option) any later version.
 *
 */

/*
 * bootup setup stuff..
 */

#include <linux/errno.h>
#include <linux/sched.h>
#include <linux/kernel.h>
#include <linux/mm.h>
#include <linux/stddef.h>
#include <linux/unistd.h>
#include <linux/ptrace.h>
#include <linux/malloc.h>
#include <linux/ldt.h>
#include <linux/user.h>
#include <linux/a.out.h>
#include <linux/tty.h>

#define DEFAULT_ROOT_DEVICE 0x0801	/* sda1 */

void
set_root_dev(void)
{
  ROOT_DEV = to_kdev_t(DEFAULT_ROOT_DEVICE);
}
